"""Added rating modul

Revision ID: b0d4c7b05fe7
Revises: ac864b1ad12c
Create Date: 2016-05-09 14:12:20.413159

"""

# revision identifiers, used by Alembic.
revision = 'b0d4c7b05fe7'
down_revision = 'ac864b1ad12c'

from alembic import op
import sqlalchemy as sa


INSERTS = """
INSERT INTO modules (id, name, description, label, label_plural, clazzpath, display, str_repr, uuid) VALUES (1001, 'ratings', '', 'Rating', 'Ratings', 'aspirant.model.rating.Rating', 'header-menu', '%s|id', '3c01e3f0b87a42faab40d673d2023d1c');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (46, 1001, '110e93584b2c41b3a13d775cbc0ceb89', 'List', 'list', 'icon-list-alt', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (47, 1001, 'ac17bb0ed27346beb015a90eb42cfba6', 'Create', 'create', 'icon-plus', 'False', '', 'hide', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (48, 1001, '68ee21e0181b42b9b7dc2379a6573d59', 'Read', 'read/{id}', 'icon-eye-open', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (49, 1001, '02c9841d6daa4bbf91f42097bbd49667', 'Update', 'update/{id}', 'icon-edit', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (50, 1001, '4a8acec5d0f24c70a0e43763e3c0817f', 'Delete', 'delete/{id}', 'icon-eye-delete', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (51, 1001, '5b6d608e03a94e6584dbfef1f1a22a43', 'Import', 'import', 'icon-import', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (52, 1001, 'bfed3cd36e0d4e02bf29ce3bc3505275', 'Export', 'export/{id}', 'icon-export', 'True', '', '', '');
"""
DELETES = """"""


def iter_statements(stmts):
    for st in [x for x in stmts.split('\n') if x]:
        op.execute(st)


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table('ratings',
    sa.Column('uuid', sa.CHAR(length=32), nullable=True),
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('uid', sa.Integer(), nullable=True),
    sa.Column('gid', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['gid'], ['usergroups.id'], name='fk_ratings_gid_usergroups', use_alter=True),
    sa.ForeignKeyConstraint(['uid'], ['users.id'], name='fk_ratings_uid_users', use_alter=True),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('uuid')
    )
    op.create_foreign_key('fk_ratings_uid_users', 'ratings', 'users', ['uid'], ['id'], use_alter=True)
    op.create_foreign_key('fk_ratings_gid_usergroups', 'ratings', 'usergroups', ['gid'], ['id'], use_alter=True)
    ### end Alembic commands ###
    iter_statements(INSERTS)


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint('fk_ratings_gid_usergroups', 'ratings', type_='foreignkey')
    op.drop_constraint('fk_ratings_uid_users', 'ratings', type_='foreignkey')
    op.drop_table('ratings')
    ### end Alembic commands ###
    iter_statements(DELETES)
