"""Added application modul

Revision ID: bf4318ff503f
Revises: 38eb5f63a8a4
Create Date: 2016-03-16 13:58:13.316550

"""

# revision identifiers, used by Alembic.
revision = 'bf4318ff503f'
down_revision = '38eb5f63a8a4'

from alembic import op
import sqlalchemy as sa


INSERTS = """
INSERT INTO modules (id, name, description, label, label_plural, clazzpath, display, str_repr, uuid) VALUES (1000, 'applications', '', 'Application', 'Applications', 'aspirant.model.application.Application', 'header-menu', '%s|id', 'bffef1249c0947eca750a6da0e8970ee');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (39, 1000, '54b3b92072684efdb53d88f002df3c91', 'List', 'list', 'icon-list-alt', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (40, 1000, '69e55533dd8c47f3ba836948fc488e4b', 'Create', 'create', 'icon-plus', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (41, 1000, '96eb6c70f8e64cf3878fb3d08a2d2a6b', 'Read', 'read/{id}', 'icon-eye-open', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (42, 1000, '58f5c91107bf4b9eb21f4a1a6e184395', 'Update', 'update/{id}', 'icon-edit', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (43, 1000, '0ffc77d8360349a58b51a144acbd3056', 'Delete', 'delete/{id}', 'icon-eye-delete', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (44, 1000, '1c24dbbc5b404eaca89edcaf1634ce87', 'Import', 'import', 'icon-import', 'False', '', '', '');
INSERT INTO actions (id, mid, uuid, name, url, icon, bundle, description, display, permission) VALUES (45, 1000, '52c2b0ab2d2f4cbda5e4ca5b3312cbac', 'Export', 'export/{id}', 'icon-export', 'True', '', '', '');
"""
DELETES = """"""


def iter_statements(stmts):
    for st in [x for x in stmts.split('\n') if x]:
        op.execute(st)


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table('applications',
    sa.Column('created', sa.DateTime(), nullable=True),
    sa.Column('updated', sa.DateTime(), nullable=True),
    sa.Column('uuid', sa.CHAR(length=32), nullable=True),
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('uid', sa.Integer(), nullable=True),
    sa.Column('gid', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['gid'], ['usergroups.id'], name='fk_applications_gid_usergroups', use_alter=True),
    sa.ForeignKeyConstraint(['uid'], ['users.id'], name='fk_applications_uid_users', use_alter=True),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('uuid')
    )
    op.create_foreign_key('fk_applications_gid_usergroups', 'applications', 'usergroups', ['gid'], ['id'], use_alter=True)
    op.create_foreign_key('fk_applications_uid_users', 'applications', 'users', ['uid'], ['id'], use_alter=True)
    ### end Alembic commands ###
    iter_statements(INSERTS)


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('applications')
    ### end Alembic commands ###
    iter_statements(DELETES)
